require 'map1'
require 'map2'
require 'map3'
require 'map4'
require 'map5'
require 'map6'
require 'map7'

require 'mapsaver'
require 'timewriter'
require 'autocorrector'
require 'tileloader'
require 'solidchecker'
require 'healththreat'
require 'scripts'

function love.load()

	-- jtktr kiterjedse
	Max_row_length, Max_col_length = 96, 96
	
	
	-- lthat jtktr mretei
	GameField_SizeX, GameField_SizeY = 32, 16
	
	
	-- lthat jtktr kimozdulsa xy-tl
	GameField_OffsetX, GameField_OffsetY = 16, 48
	
	-- csempekszlet mrete
	TileNum = 15*15
	
	-- randomvltozk	
	random_X, random_Y, random_K = 1, 1, 1

	-- ciklusvltozk
	i, j, k, x, y = 0, 0, 0, 0, 0
	
	-- idmrs 
	t = 0
	
	-- oxignszint + hmrsklet + dtum	
	O_level = 90
	Temperature = 40
	
	Days, Hours, Minutes, Seconds, MidnightMin = 1, 0, 0, 0, 0
	
	-- debugmd engedlyezse
	
	DebuggingMode = false
	
	TileChangeTriggered = false
	Map = false

	ChosenTileNum = 49 -- editor mdban kivlasztott tile neve
	
	-- kvetkez tile neve (a mez szmt trolja, amire lpnk)
	NextTileNum = 1
	
	--mozgskpessget ellenrz vltozlove	
	Can_I_Move = true
	
	--pickup szomszdsgot ellenrz vltoz
	Pickup = false
	
	-- inventory
	ChosenObject = 70
	
	InvNums = { 0, 0, 0, 0, 0 } --mibl mennyi van
	
	-- kldetselemek megltt trol tbla
	ElementsFound = { false, false, false, false, false, false, false }
	
	-- betkszlet
	font = love.graphics.newFont("slkscre.ttf", 16)
	love.graphics.setFont(font)
	
	-- hangvltozk
	pickupsound = love.audio.newSource("pickup.wav", "static")
	levchangesound = love.audio.newSource("levelchange.wav", "static")
	exitfailsound = love.audio.newSource("exitfailed.wav", "static")
	walksound_dirt = love.audio.newSource("dirtwalk.wav", "static")
	walksound_metal = love.audio.newSource("metalwalk.wav", "static")

	
	-- lehetsges plyanevek
	CurrentLevel = 5
	NameSet = {}
	NameSet[1] = "The Surface"
	NameSet[2] = "Sanctuary"
	NameSet[3] = "Machine"
	NameSet[4] = "The Core"
	NameSet[5] = "TITLEMAP"
	NameSet[6] = "The God"
	NameSet[7] = "Opening"
	
	-- fjlrs mappjnak azonostsa
	love.filesystem.setIdentity("7 Days Bad Luck")
	
	-- csempk betltse
	LoadingTiles()
	
	-- jtkos ltrehozsa	
	Player = {X_Pos = 24, Y_Pos = 54, HP = 100, Current_Sprite_Num = 84}
	
	-- jtktr ltrehozsa, kezdeti rtkads
	-- MapTable[OSZLOPSZM][SORSZM], fontos!!!
	
	MapLayer_A = {}		-- alaphttr
	MapLayer_B = {}		-- intermission textrk lakhelye
	MapLayer_C = {}		-- mozg dolgok layere	

	LoadMap_5()
	ScriptLoader()
	
end

-- kirajzols

function love.draw()
	
	-- jtktr
	
	for j=1, GameField_SizeY do
		for i=1, GameField_SizeX do
			love.graphics.drawq(MainTileFile, Tileset[MapLayer_A[i+GameField_OffsetX][j+GameField_OffsetY]], (i-1)*32, (j-1)*32)
			love.graphics.drawq(MainTileFile, Tileset[MapLayer_B[i+GameField_OffsetX][j+GameField_OffsetY]], (i-1)*32, (j-1)*32)
			if Tileset[MapLayer_C[i+GameField_OffsetX][j+GameField_OffsetY]] ~= 666
			then
			love.graphics.drawq(MainTileFile, Tileset[MapLayer_C[i+GameField_OffsetX][j+GameField_OffsetY]], (i-1)*32, (j-1)*32)
			end
			
		end	
	end
	
	-- HUD alapjai (mrete: 256x1024 -> a pixelHUD mrete 32x 128 lesz, azaz 8x-os nagyts)

	love.graphics.drawq(MainTileFile, Tileset[1337], 0, 528)
	love.graphics.drawq(MainTileFile, Tileset[1337], 512, 528)
	
	love.graphics.drawq(MainTileFile, Tileset[76], 10, 545)
	love.graphics.print(Player.HP .. " HP", 48, 547)
	love.graphics.print(string.format("%.1f", (((MidnightMin/1440)*100)/6)) .. "% to -1 ", 48, 565)
	
	love.graphics.drawq(MainTileFile, Tileset[77], 8, 580)
	love.graphics.print(O_level .. "% of neces-", 48, 586)
	love.graphics.print("sary O2 level", 48, 604)
	
	love.graphics.drawq(MainTileFile, Tileset[78], 8, 625)
	love.graphics.print(Temperature .. " degrees", 48, 625)
	
	if Temperature <=15	
	then
		love.graphics.print("Hypothermia!", 48, 645)
	end
	
		if Temperature >= 35	
	then
		love.graphics.print("Hyperthermia!", 48, 645)
	end
	
	
	love.graphics.drawq(MainTileFile, Tileset[79], 6, 665)
	love.graphics.print("Day " .. Days .. ", " .. Hours .. ":" .. Minutes .. ":" .. Seconds, 48, 665)
	love.graphics.print( MidnightMin .. " mins today", 48, 685)
	
	love.graphics.drawq(MainTileFile, Tileset[80], 8, 705)
	love.graphics.print(NameSet[CurrentLevel], 48, 715)	
	
	-- inventoryrendszer
	
	love.graphics.drawq(MainTileFile, Tileset[ChosenObject], 240, 568)
	love.graphics.print(InvNums[ChosenObject-69], 240, 568)
	
	love.graphics.drawq(MainTileFile, Tileset[70], 522, 545)
	love.graphics.print("Fruit from", 558, 547)
	love.graphics.print("the trees", 558, 565)
	
	love.graphics.drawq(MainTileFile, Tileset[71], 518, 585)
	love.graphics.print("Preserved food", 558, 586)
	love.graphics.print("(openable can)", 558, 604)

	love.graphics.drawq(MainTileFile, Tileset[72], 518, 625)
	love.graphics.print("bottle of water", 558, 625)
	love.graphics.print("(consumable)", 558, 645)

	love.graphics.drawq(MainTileFile, Tileset[73], 518, 665)
	love.graphics.print("sack filled ", 558, 665)
	love.graphics.print("with ice", 558, 685)	
	
	love.graphics.drawq(MainTileFile, Tileset[74], 522, 705)
	love.graphics.print("Oxygenmask", 558,  715)
	
	-- mibl mennyi kirsa jobb als sarokba
	love.graphics.print(InvNums[1], 525, 567)
	love.graphics.print(InvNums[2], 525, 607)
	love.graphics.print(InvNums[3], 525, 647)
	love.graphics.print(InvNums[4], 525, 687)
	love.graphics.print(InvNums[5], 525, 722)
	
	-- kldetselemek
	
	for k=1,4 do
	
		love.graphics.drawq(MainTileFile, Tileset[90+k-1], 304+48*(k-1), 544)
		
		if ElementsFound[k] == true
		then
			love.graphics.drawq(MainTileFile, Tileset[88], 304+48*(k-1), 592)	
		else
			love.graphics.drawq(MainTileFile, Tileset[89], 304+48*(k-1), 592)
		end

	end
	
	for k=1,3 do
	
		love.graphics.drawq(MainTileFile, Tileset[94+k-1], 304+72*(k-1), 640)
		
		if ElementsFound[k+4] == true
		then
			love.graphics.drawq(MainTileFile, Tileset[88], 304+72*(k-1), 688)	
		else
			love.graphics.drawq(MainTileFile, Tileset[89], 304+72*(k-1), 688)
		end

	end	

	love.graphics.print("Sanctuary entr.:", 816, 600)	
	love.graphics.print("Machine entrance:", 816, 648)	
	love.graphics.print("Core entrance:", 816, 696)
	
	if not ElementsFound[1]
	then
			love.graphics.print("acces denied", 816, 616)
	else
			love.graphics.print("access granted", 816, 616)	
	end
	
	if not ElementsFound[2]
	then
			love.graphics.print("acces denied", 816, 664)
	else	
			love.graphics.print("access granted", 816, 664)	
	end	
	
	if not ElementsFound[5]
	then
			love.graphics.print("acces denied", 816, 712)
	else	
			love.graphics.print("access granted", 816, 712)	
	end		
	
	if ElementsFound[7]
	then
			love.graphics.print("finish him! ...or whatever.", 384, 512)	
	end

	-- szvegek

	if pickup_text
		then
			love.graphics.print("Search supplies", 816, 544)
		end
		
	if StoryItem_text
		then
			love.graphics.print("Get story item!", 816, 544)		
		end

	if Gateway_text
		then
			love.graphics.print("Enter " .. NameSet[CurrentLevel+1], 816, 544)		
		end
		
	
	if CurrentLevel == 5
	then
		if map5_text[1]
		then
			love.graphics.print("Leave the Planet", 816, 544)
		end
		
		if map5_text[2]
		then
			love.graphics.print("About the author", 816, 544)
			if GameField_OffsetY == 5 
			then
				for k=1, 30 do
					love.graphics.print(author_text[k], 16, 32 + 16*(k-1))
				end		
			end
		end

		if map5_text[3]
		then
			love.graphics.print("Start Simulation", 816, 544)
			if GameField_OffsetY == 5 
			then
				for k=1, 30 do
					love.graphics.print(intro_text[k], 16, 32 + 16*(k-1))
				end				
			end			
		end	
			
	end
	
			if Ending1
			then
				VictoryScript()			
				for k=1, 30 do
					love.graphics.print(fail_text[k], 16, 32 + 16*(k-1))
				end				
			end	
			
			if Ending2
			then
				VictoryScript()				
				for k=1, 30 do
					love.graphics.print(survived_text[k], 16, 32 + 16*(k-1))
				end				
			end	
			
			if Ending3
			then
				VictoryScript()					
				for k=1, 30 do
					love.graphics.print(victory_text[k], 16, 32 + 16*(k-1))
				end				
			end			

	-- debug cuccok
	
	if DebuggingMode then
	
		love.graphics.print("DEBUGGING MODE ENABLED", 16, 16)
		
		if Can_I_Move then
			love.graphics.print(Player.X_Pos, 962, 730)
			love.graphics.print(Player.Y_Pos, 992, 730)	
		end
	
	if Map 
	then
		for j=1, Max_row_length do
			for i=1, Max_col_length do
				love.graphics.drawq(MainTileFile, Tileset[MapLayer_A[i][j]], (i-1)*8, (j-1)*8)
				love.graphics.drawq(MainTileFile, Tileset[MapLayer_B[i][j]], (i-1)*8, (j-1)*8)
			
			end	
		end
	end
	
		if TileChangeTriggered then
		love.graphics.drawq(MainTileFile, Tileset[ChosenTileNum], 800, 666)
		end
	
		if asd then
		love.graphics.print("Map saved!", 800, 730)	
		end
	end
	
	

end

-- minden frame-en megtrtn dolgok

function love.update(dt)
	MapLayer_C[Player.X_Pos][Player.Y_Pos] = Player.Current_Sprite_Num
	ScriptLoader()	

	if Ending1 or Ending2 or Ending3
	then
		VictoryScript()
	end
	
	t = t+1
	
	if t == 320
	then
		t = 0
	end
	
	if t % 20 == 0
	then
		for j=1, Max_row_length do
			for i=1, Max_col_length do
		
		
				-- vz meganimlsa	
		
				if MapLayer_A[j][i] == 2
				then
					MapLayer_A[j][i] = 3
				elseif MapLayer_A[j][i] == 3
				then
					MapLayer_A[j][i] = 2
				end	
				
				-- tz meganimlsa	
		
				if MapLayer_A[j][i] == 21
				then
					MapLayer_A[j][i] = 22
				elseif MapLayer_A[j][i] == 22
				then
					MapLayer_A[j][i] = 21
				end	

				-- ertr meganimlsa	
		
				if MapLayer_A[j][i] == 41
				then
					MapLayer_A[j][i] = 42
				elseif MapLayer_A[j][i] == 42
				then
					MapLayer_A[j][i] = 41
				end	

				-- szuszpenzis tartly meganimlsa	
		
				if MapLayer_A[j][i] == 52
				then
					MapLayer_A[j][i] = 53
				elseif MapLayer_A[j][i] == 53
				then
					MapLayer_A[j][i] = 52
				end	

				-- lzer meganimlsa	
		
				if MapLayer_A[j][i] == 57
				then
					MapLayer_A[j][i] = 58
				elseif MapLayer_A[j][i] == 58
				then
					MapLayer_A[j][i] = 57
				end						

				-- monitor meganimlsa	
		
				if MapLayer_A[j][i] == 61
				then
					MapLayer_A[j][i] = 62
				elseif MapLayer_A[j][i] == 62
				then
					MapLayer_A[j][i] = 61
				end					
			
			end	
		end
	end
end


-- billparancsok
function love.keyreleased(key)

	-- mindegy mit nyomsz, megtrtnik
	
	if CurrentLevel == 1
	or CurrentLevel == 2
	or CurrentLevel == 3
	or CurrentLevel == 4
	then
		TimeGoesOn()
		HealthThreat()
	end
	
	if CurrentLevel == 5 and GameField_OffsetY == 5 
	then
		if map5_text[3]
		then
			CurrentLevel = 1
			LoadMap_1()
			Player.Current_Sprite_Num = 84
			Can_I_Move = true
			GameField_OffsetY = Player.Y_Pos - 5
		elseif  map5_text[2]
		then
			Can_I_Move = true
			GameField_OffsetY = Player.Y_Pos - 5
		end
	end
	
	if CurrentLevel == 6
	then
		love.event.push('quit')
	end
	
	-- mozgs jtkossal
	
	if key == "w" and 3 <= Player.Y_Pos
	then
		NextTileNum = MapLayer_A[Player.X_Pos][Player.Y_Pos - 1]
		WalkSoundHandler()
		SolidChecker()
		if Can_I_Move
		then		
			Player.Y_Pos = Player.Y_Pos - 1
			Player.Current_Sprite_Num = 87
			MapLayer_C[Player.X_Pos][Player.Y_Pos + 1] = 666
			
			if Player.Y_Pos - GameField_OffsetY < 3 and GameField_OffsetY > 0
			then
				GameField_OffsetY = GameField_OffsetY - 1
			end
		end
	end

	if key == "s" and Player.Y_Pos <= Max_col_length - 1
	then
		NextTileNum = MapLayer_A[Player.X_Pos][Player.Y_Pos + 1]
		WalkSoundHandler()
		SolidChecker()
		if Can_I_Move
		then		
			Player.Y_Pos = Player.Y_Pos + 1
			Player.Current_Sprite_Num = 85
			MapLayer_C[Player.X_Pos][Player.Y_Pos - 1] = 666

			if GameField_SizeY - (Player.Y_Pos - GameField_OffsetY) < 3 and GameField_OffsetY < Max_col_length - GameField_SizeY
			then
				GameField_OffsetY = GameField_OffsetY + 1
			end
		end
		
	end

	if key == "a" and 3 <= Player.X_Pos 
	then
		NextTileNum = MapLayer_A[Player.X_Pos - 1][Player.Y_Pos]
		WalkSoundHandler()
		SolidChecker()
		if Can_I_Move
		then
			Player.X_Pos = Player.X_Pos - 1
			Player.Current_Sprite_Num = 86
			MapLayer_C[Player.X_Pos + 1][Player.Y_Pos] = 666

			if Player.X_Pos - GameField_OffsetX < 3 and GameField_OffsetX > 0
			then
				GameField_OffsetX = GameField_OffsetX - 1
			end
		end
				
	end

	if key == "d" and Player.X_Pos <= Max_row_length - 1
	then
		NextTileNum = MapLayer_A[Player.X_Pos + 1][Player.Y_Pos]
		WalkSoundHandler()
		SolidChecker()
		if Can_I_Move
		then		
			Player.X_Pos = Player.X_Pos + 1	
			Player.Current_Sprite_Num = 84
			MapLayer_C[Player.X_Pos - 1][Player.Y_Pos] = 666

			if GameField_SizeX - (Player.X_Pos - GameField_OffsetX) < 3 and GameField_OffsetX < Max_row_length - GameField_SizeX
			then
				GameField_OffsetX = GameField_OffsetX + 1
			end
		end
	end	

-- hasznl gomb	
	
	if key == "f"
	then
		-- trgyfelvtel hordozkbl
		AddSomePickups()
		-- plya elhagysa
		if Gateway_text
		then
			ExitScript()
		end
		-- kldetselemek felvtele
		if StoryItem_text
		then
			for j=Player.X_Pos-1, Player.X_Pos+1 do		
				for i=Player.Y_Pos-1, Player.Y_Pos+1 do
					if 90 <= MapLayer_B[j][i] and MapLayer_B[j][i] <= 96
					then
						ElementsFound[MapLayer_B[j][i]-89] = true
						MapLayer_B[j][i] = 666
						
						love.audio.play(pickupsound)
						if not pickupsound:isStopped()
						then
						pickupsound:rewind()
						end
						
					end
				end
			end
		end
		-- fmen esemnyek
		if CurrentLevel == 5
		then
			
			if map5_text[1]
			then
				love.event.push('quit')
			end	
			
			if map5_text[2] or map5_text[3]
			then
				Can_I_Move = false
				GameField_OffsetY = 5
			end	
		end
		
	end
	
	if key == 'q' and ChosenObject > 70
	then
		ChosenObject = ChosenObject - 1
	end
	
	if key == 'e' and ChosenObject < 74
	then
		ChosenObject = ChosenObject + 1
	end	
	
	-- itemhasznlat gomb	
	if key == "x"
	then
		UseItem()		
	end
	
	-- debugging funkcik (jtk kzben nem mkdnek, csak a vltozt kell truev tenni, de ehhez piszklni kell a kdot!)
	
	if DebuggingMode
	then
	
		if key == " "
		then		
			AutoCorrector()	
		end
	
		if key == "t"
		then
			TileChangeTriggered = not TileChangeTriggered
			SaveMap() 
		end
		
		if key == "q" and 2 <= ChosenTileNum
		then
			ChosenTileNum = ChosenTileNum - 1
		
		end
		
		if key == "e" and ChosenTileNum <= TileNum
		then 
			ChosenTileNum = ChosenTileNum + 1
			
		end
		
		if TileChangeTriggered
		then
			if (12 <= ChosenTileNum and ChosenTileNum <= 16) 
			or  (25 <= ChosenTileNum and ChosenTileNum <= 32) 
			or (90 <= ChosenTileNum and ChosenTileNum <= 96) 
			then
				MapLayer_B[Player.X_Pos][Player.Y_Pos] = ChosenTileNum
				
			elseif (37 <= ChosenTileNum and ChosenTileNum <= 38) or ChosenTileNum == 69
			then
				--MapLayer_A[Player.X_Pos+1][Player.Y_Pos] = ChosenTileNum
				--MapLayer_A[Player.X_Pos+2][Player.Y_Pos] = ChosenTileNum			
				--MapLayer_A[Player.X_Pos+3][Player.Y_Pos] = ChosenTileNum
				--MapLayer_A[Player.X_Pos+4][Player.Y_Pos] = ChosenTileNum
				
				MapLayer_A[Player.X_Pos][Player.Y_Pos] = ChosenTileNum

				--MapLayer_A[Player.X_Pos][Player.Y_Pos+1] = ChosenTileNum
				--MapLayer_A[Player.X_Pos][Player.Y_Pos+2] = ChosenTileNum				
				--MapLayer_A[Player.X_Pos][Player.Y_Pos+3] = ChosenTileNum
				--MapLayer_A[Player.X_Pos][Player.Y_Pos+4] = ChosenTileNum
			else
				MapLayer_A[Player.X_Pos][Player.Y_Pos] = ChosenTileNum
			end	
		end
		
		if key == "c" and TileChangeTriggered
		then
			MapLayer_A[Player.X_Pos][Player.Y_Pos] = 666
			MapLayer_B[Player.X_Pos][Player.Y_Pos] = 666
		end
		
		if key == "r"
		then
			Map = not Map
		end		
		
	
	end
	
end

